return function()

local B = CBW_Battle
local cooldown = TICRATE*9/5

B.Action.RoboMissile=function(mo,doaction)
	local player = mo.player
-- 	player.actionstate = 0
	//Run checks
	if not(B.CanDoAction(player)) then
		return
	end
	if B.PlayerButtonPressed(player,player.battleconfig_special,true) then
		B.DrawAimLine(player)
	end
	//Action Info
	player.actiontext = "RC Mega Missile"
	player.actionrings = 15
	if doaction == 2 then
		player.actiontextflags = 2
		player.action2text = "Hold: Aim"
	end
	//Launch Missile
	if doaction == 1
		player.actionstate = 1
		player.actiontime = 0
		B.PayRings(player,player.actionrings)
-- 		S_StartSound(missile,sfx_s3kb8)
		
		//Get missile type
		local t
		if mo.eflags&MFE_UNDERWATER then t = MT_CRAWLAMISSILE
		elseif P_IsObjectOnGround(mo) then t = MT_CRAWLAMISSILE
		else t = MT_BASHMISSILE end		
		for n = 1, 1
			//Spawn missile
			local missile = P_SPMAngle(mo,t,mo.angle,0)
			//Missile properties
			if missile and missile.valid then
				missile.color = player.skincolor
				missile.scale = 2*FRACUNIT
				missile.blockable = 1
				missile.block_stun = 80
				missile.block_hthrust = 13
				missile.block_vthrust = 4
				//Thrust
				if n == 0 then
					P_SetObjectMomZ(missile,FRACUNIT*2,2)
				end
				if n == 1 then
					P_Thrust(missile,mo.angle+ANGLE_157h,FRACUNIT*2)
				end
				if n == 2 then
					P_Thrust(missile,mo.angle-ANGLE_135,FRACUNIT*2)
					P_SetObjectMomZ(missile,FRACUNIT,1)
				end
				B.RoboMissileTransferCarry(player,missile)
			end
		end
	return end

	if player.actionstate == 1 then
		if doaction == 1 then
			player.actiontime = $+1
		else
			B.ApplyCooldown(player,max(0,cooldown-player.actionstate))
			player.actiontime = 0
			player.actionstate = 0
		end
	end
end

B.RoboMissileTransferCarry=function(player,missile)
	local carried = player.carry_id
	if not(carried) then return end
	if not(missile.flags&MF_MISSILE) then return end
	B.DebugPrint("carry_id "..tostring(carried),DF_PLAYER)
	carried.tracer = missile
	if carried.player then
		carried.player.powers[pw_carry] = CR_GENERIC
	end
	P_TeleportMove(carried,missile.x,missile.y,missile.z-carried.height)
	player.carry_id = nil
	missile.target = carried
	missile.carry = true
end

B.RoboMissileSpawn=function(mo)
	mo.robomissile_init = true
	mo.phase = 1
	mo.speedlimit = 30*FRACUNIT
	mo.time = 0
	P_SetObjectMomZ(mo,FRACUNIT*4,true)
	mo.flags = $|MF_NOCLIPTHING
end

B.RoboMissileThinker=function(mo)
	if not(mo.valid and mo.flags&MF_MISSILE) then return end
	if mo.launchtime == nil then 
		mo.launchtime = P_RandomRange(20,25)
	end
	mo.time = $+1
	if mo.phase == 1
		if mo.type != MT_CRAWLAMISSILE then
			mo.momz = $*95/100
		end
		if P_IsObjectOnGround(mo) then
			mo.phase = 2
			mo.time = 0
 			mo.flags = $&~(MF_GRENADEBOUNCE)
			S_StartSound(mo,sfx_s3k48)
		elseif mo.time > mo.launchtime and not(mo.type == MT_CRAWLAMISSILE) then
			mo.time = 0
			mo.phase = 2
			S_StartSound(mo,sfx_s3ka0)
		end
	end
	local w = B.WaterFactor(mo)
	if mo.phase == 2 then
		mo.flags = $&~MF_NOCLIPTHING
		B.RoboMissileRemoteControl(mo)
		P_Thrust(mo,mo.angle,FRACUNIT*2/w)
		B.ControlThrust(mo,FRACUNIT*97/100,mo.speedlimit/w)
	end
	if (mo.type == MT_CRAWLAMISSILE) then
		B.CrawlaMissileGravity(mo)
	end
	if mo.phase == 2 and not(mo.time&3) then
		local thrust = mo.scale*4
		local ang = P_RandomRange(170,190)*ANG1+mo.angle
		local x = mo.x+P_ReturnThrustX(mo,ang,thrust)
		local y = mo.y+P_ReturnThrustY(mo,ang,thrust)
		if w == 1 then
			P_SpawnMobj(x,y,mo.z,MT_DUST)
		else
			P_SpawnMobj(x,y,mo.z,MT_SMALLBUBBLE)
		end
	end
end

B.CrawlaMissileGravity = function(mo)
	if mo.floorz > mo.z then
		mo.z = mo.floorz
		mo.momz = 0
	end
	if mo.ceilingz < mo.z+mo.height then
		mo.z = mo.ceilingz-mo.height
		mo.momz = 0
	end
end

B.RoboMissileFuse=function(mo)
	if not(mo.valid and mo.health) or mo.type == MT_CRAWLAMISSILE or mo.type == MT_BASHMISSILE or mo.type == MT_JETJAWMISSILE then return end
	P_KillMobj(mo)
	return true
end

B.RoboMissileRemoteControl = function(mo)
	if not(mo.target and mo.target.valid and mo.target.player) then return end //Owner invalid
	if mo.carry and mo.target.tracer != mo then return end //No longer carrying
	local remote = B.PlayerButtonPressed(mo.target.player,mo.target.player.battleconfig_special)
	local target = mo.target
	local player = target.player
	local cmd = player.cmd
	local water = B.WaterFactor(mo)
	if P_PlayerInPain(player) or not(player.playerstate == PST_LIVE) then return end
	//Jump
	if remote and mo.type == MT_CRAWLAMISSILE and P_IsObjectOnGround(mo) then
		if B.PlayerButtonPressed(player,BT_JUMP,false) then
			S_StartSound(mo,sfx_cdfm02)
			P_SetObjectMomZ(mo,FRACUNIT*10/water,true)
			mo.phase = 1
		end
	end
	if mo.phase == 2 then
		local exposed = (
			(mo.type == MT_CRAWLAMISSILE and not(P_IsObjectOnGround(mo)))
			or (mo.type == MT_BASHMISSILE and water==2)
			or (mo.type == MT_JETJAWMISSILE and water==1)
		)
		if not(exposed) or (mo.type == MT_CRAWLAMISSILE) then 
			mo.fuse = 0
		elseif not(mo.fuse) then
			mo.fuse = TICRATE
			if(mo.type == MT_JETJAWMISSILE) then
				mo.flags = $&~MF_NOGRAVITY
			end
		end
		//Air vertical control
		if not(mo.type == MT_CRAWLAMISSILE) and not(mo.carry) and remote then
			local zmove = P_MobjFlip(mo)*B.FixedLerp(0,player.mo.z-mo.z+player.mo.height,FRACUNIT/100)
			P_SetObjectMomZ(mo,zmove,1)
		end
		
		//Terrain avoidance
		if not(mo.type == MT_CRAWLAMISSILE) and mo.z > mo.floorz and mo.z+mo.height < mo.ceilingz
			mo.z = min(mo.ceilingz-mo.height*2,max(mo.floorz+mo.height,$))
		end

		//Carrier controls
		if mo.carry then
			mo.angle = mo.target.angle
			local zmove = FRACUNIT*cmd.forwardmove/50/water
		elseif remote //Remote controls
			local dist = min(FRACUNIT/4*FRACUNIT,R_PointToDist2(mo.x,mo.y,target.x,target.y))*2
			local x2 = target.x+P_ReturnThrustX(nil,target.angle,dist)
			local y2 = target.y+P_ReturnThrustY(nil,target.angle,dist)
			mo.angle = R_PointToAngle2(mo.x,mo.y,x2,y2)
		end
	end
end

B.RoboMissilePeer=function(mo,other)
	if not(mo.robomissile_init and other.robomissile_init and mo.target == other.target and mo.phase == 2 and other.phase == 2) then return end
	local angle = R_PointToAngle2(mo.x,mo.y,other.x,other.y)
	local thrust = FRACUNIT
	P_Thrust(mo,angle+ANGLE_180,thrust)
	P_Thrust(other,angle,thrust)
end

B.RoboMissileResetCarry=function(mo)
	if mo.target and mo.target.player
		and mo.target.player.powers[pw_carry] == CR_GENERIC
		then
			mo.target.player.powers[pw_carry] = 0
			mo.target = nil
	end
end

end